
import java.io.*;
import java.util.ArrayList;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class userHandler {
	private ArrayList<essayStats> es;
	private String userName;
	private String userFile;
	
	
	public userHandler(){	
	}
	
	/**
	 * This method is intended for create a new user in the database.
	 * @param newUser new user to the database.
	 */
	public userHandler(String newUser) throws Exception{
    	int aux = addUserToFile(newUser);
    	createUserFile(newUser, aux);
    	es = new ArrayList<essayStats>();
	}
	
	/**
	 * This part is for add a user in the 'user.xml' file.
	 * @return 
	 */
	private int addUserToFile(String newUser) throws Exception{
		File file = new File("UserDatabase.xml");
		 
		//Create instance of DocumentBuilderFactory
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	 
		//Get the DocumentBuilder
		DocumentBuilder docBuilder = factory.newDocumentBuilder();
	 
		//Parsing XML Document
		Document doc = docBuilder.parse(file);
		
		//Pointing to document root element
		Element root = doc.getDocumentElement();
	 
		//Get the number of 'user' nodes
		NodeList userList = doc.getElementsByTagName("user");
        int userNumber = userList.getLength()+1;
		
		//create child element having tagName=user
		Element childElement = doc.createElement("user");
		
		//Add the attribute to the child
		childElement.setAttribute("userfile","user"+userNumber);
		
		//Add the text to the child
		childElement.setTextContent(newUser);
	 
		//Adding number tag to root element
		root.appendChild(childElement);
		
		//setting up a transformer
	    TransformerFactory transfac = TransformerFactory.newInstance();
	    Transformer trans = transfac.newTransformer();
	 
	    //generating string from xml tree
	    StringWriter sw = new StringWriter();
	    StreamResult result = new StreamResult(sw);
	    DOMSource source = new DOMSource(doc);
	    trans.transform(source, result);
	    String xmlString = sw.toString();
	 
	    //Saving the XML content to File
	    OutputStream f0;
	    byte buf[] = xmlString.getBytes();
	    f0 = new FileOutputStream("UserDatabase.xml");
	    for(int i=0;i<buf .length;i++) {
	    	f0.write(buf[i]);
	    }
		f0.close();
		buf = null;
		return userNumber;
	}
	
	private void createXML(String filename) throws Exception{
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();

        // Here instead of parsing an existing document we want to
        // create a new one.
        Document testDoc = builder.newDocument();

        // This creates a new tag named 'testElem' inside the document
        //  and sets its data to 'TestContent'
        Element el = testDoc.createElement("root");
        testDoc.appendChild(el);
        
        //setting up a transformer
	    TransformerFactory transfac = TransformerFactory.newInstance();
	    Transformer trans = transfac.newTransformer();
	 
	    //generating string from xml tree
	    StringWriter sw = new StringWriter();
	    StreamResult result = new StreamResult(sw);
	    DOMSource source = new DOMSource(testDoc);
	    trans.transform(source, result);
	    String xmlString = sw.toString();
	 
	    //Saving the XML content to File
	    OutputStream f0;
	    byte buf[] = xmlString.getBytes();
	    f0 = new FileOutputStream(filename+".xml");
	    for(int i=0;i<buf .length;i++) {
	    	f0.write(buf[i]);
	    }
		f0.close();
		buf = null;
	}
	
	/**
	 * This part just create a new 'userX.xml' file.
	 * @param newUser The 
	 */
	private void createUserFile(String newUser, int userNumber) throws Exception{
		createXML("user"+userNumber);
		userFile = "user"+userNumber+".xml";
		
		//File file = new File("user"+userNumber+".xml");
		 
		//Create instance of DocumentBuilderFactory
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	 
		//Get the DocumentBuilder
		DocumentBuilder docBuilder = factory.newDocumentBuilder();
	 
		//Parsing XML Document
		Document doc = docBuilder.parse(new File("user"+userNumber+".xml"));
		
		//Pointing to document root element
		Element root = doc.getDocumentElement();
		
		//create child element having tagName=user
		Element childElement = doc.createElement("user");
		
		//Add the text to the child
		childElement.setTextContent(newUser);
	 
		//Adding number tag to root element
		root.appendChild(childElement);
		
		//setting up a transformer
	    TransformerFactory transfac = TransformerFactory.newInstance();
	    Transformer trans = transfac.newTransformer();
	 
	    //generating string from xml tree
	    StringWriter sw = new StringWriter();
	    StreamResult result = new StreamResult(sw);
	    DOMSource source = new DOMSource(doc);
	    trans.transform(source, result);
	    String xmlString = sw.toString();
	 
	    //Saving the XML content to File
	    OutputStream f0;
	    byte buf[] = xmlString.getBytes();
	    f0 = new FileOutputStream("user"+userNumber+".xml");
	    for(int i=0;i<buf .length;i++) {
	    	f0.write(buf[i]);
	    }
		f0.close();
		buf = null;
	}
	
	public ArrayList<essayStats> getEs() {
		return es;
	}
	
	public void setEs(ArrayList<essayStats> es) {
		this.es = es;
	}
	
	public String getUserName() {
		return userName;
	}
	
	public String getUserFile(){
		return userFile;
	}
	
	public void setUserName(String userName) {
		this.userName = userName;
	}
	
	/**
	 * This method is intended for searching for an existing user on the 
	 * database.
	 * @param user the registered user.
	 * @return
	 * @throws Exception 
	 */
	public boolean searchUser(String user) throws Exception{
		setUserName(user);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document doc = builder.parse(new File("UserDatabase.xml"));
        NodeList userList = doc.getElementsByTagName("user");
        int userNumber = userList.getLength();
        for(int i = 0; i < userNumber; i++){
        	Node userNode = userList.item(i);
        	if(userNode.getNodeType() == Node.ELEMENT_NODE){
        		Element element = (Element) userNode;
        		System.out.println(element.getTextContent());
        		if(element.getTextContent().equals(user)){
        			userFile = element.getAttribute("userfile")+".xml";
        			System.out.println(userFile);
        			return true;
        		}
        	}
        }
        return false;
	}
	
	/**
	 * Loads the parameters in 'userX.xml' in the 'es' essayStats array list.
	 * @throws Exception
	 */
	public void loadStats() throws Exception{
		es = new ArrayList<essayStats>();
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document doc = builder.parse(new File(userFile));
        NodeList userList = doc.getElementsByTagName("ensayo");
        essayStats aux = new essayStats();
        int essayNumber = userList.getLength();
        for(int i = 0; i < essayNumber; i++){
        	Node userNode = userList.item(i);
        	if(userNode.getNodeType() == Node.ELEMENT_NODE){
        		Element element = (Element) userNode;
        		NodeList nl = element.getChildNodes();
        		for(int j = 0; j < nl.getLength(); j++){
        			Node shit = nl.item(j);
        			if(shit.getNodeType()==Node.ELEMENT_NODE){
        				Element stuff = (Element) shit;
        				if(stuff.getTagName().equals("numero")){
        					System.out.println("acm1pt n");
        					aux.setNumber(Integer.parseInt(stuff.getTextContent()));
        				}
        				else if(stuff.getTagName().equals("buenas")){
        					aux.setGood(Integer.parseInt(stuff.getTextContent()));
        					System.out.println("acm1pt g");
        				}
        				else if(stuff.getTagName().equals("malas")){
        					aux.setBad(Integer.parseInt(stuff.getTextContent()));
        					System.out.println("acm1pt b");
        				}
        				else if(stuff.getTagName().equals("omitidas")){
        					aux.setOmitted(Integer.parseInt(stuff.getTextContent()));
        					System.out.println(aux.getNumber());
        					es.add(new essayStats(aux));
        				}
        			}
        		}
        	}
        }
        
	}
	
	public void saveStats(essayStats newStat, String userFile) throws Exception{
		es.add(newStat);
		
		File file = new File(userFile);
		 
		//Create instance of DocumentBuilderFactory
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	 
		//Get the DocumentBuilder
		DocumentBuilder docBuilder = factory.newDocumentBuilder();
	 
		//Parsing XML Document
		Document doc = docBuilder.parse(file);
		
		//Pointing to document root element
		Element root = doc.getDocumentElement();
		
		//create child element having tagName=user
		Element childElement = doc.createElement("ensayo");
	 
		//Adding number tag to root element
		root.appendChild(childElement);
		
		Element ensayo = null;
		
		NodeList userList = doc.getElementsByTagName("ensayo");
        int userNumber = userList.getLength();
        for(int i = 0; i < userNumber; i++){
        	Node user = userList.item(i);
        	if(user.getNodeType() == Node.ELEMENT_NODE){
        		ensayo = (Element) user;
        	}
        }    
		
		//create child element having tagName=user
		Element childElement2 = doc.createElement("numero");
		
		//Add the attribute to the child
		childElement2.setTextContent(""+newStat.getNumber());
		
		//create child element having tagName=user
		Element childElement3 = doc.createElement("buenas");
		
		//Add the attribute to the child
		childElement3.setTextContent(""+newStat.getGood());
		
		//create child element having tagName=user
		Element childElement4 = doc.createElement("malas");
		
		//Add the attribute to the child
		childElement4.setTextContent(""+newStat.getBad());
		
		//create child element having tagName=user
		Element childElement5 = doc.createElement("omitidas");
		
		//Add the attribute to the child
		childElement5.setTextContent(""+newStat.getOmitted());
 
		//Adding number tag to root element
		ensayo.appendChild(childElement2);
		ensayo.appendChild(childElement3);
		ensayo.appendChild(childElement4);
		ensayo.appendChild(childElement5);
		
		//setting up a transformer
	    TransformerFactory transfac = TransformerFactory.newInstance();
	    Transformer trans = transfac.newTransformer();
	 
	    //generating string from xml tree
	    StringWriter sw = new StringWriter();
	    StreamResult result = new StreamResult(sw);
	    DOMSource source = new DOMSource(doc);
	    trans.transform(source, result);
	    String xmlString = sw.toString();
	 
	    //Saving the XML content to File
	    OutputStream f0;
	    byte buf[] = xmlString.getBytes();
	    f0 = new FileOutputStream(userFile);
	    for(int i=0;i<buf .length;i++) {
	    	f0.write(buf[i]);
	    }
		f0.close();
		buf = null;

	}
	
	public essayStats getEssay(int i){
		return es.get(i);
	}
	
}
